﻿var showmap = false;
var resturl = 'http://optimizer2.routesavvy.com/RSAPI.svc/';

function showMap() {

	if ($('#showMap').prop('checked')) {
		$('#routeMap').show();
		showmap = true;
	}
	else {
		$('#routeMap').hide();
		showmap = false;
	}
}

function post_BasicOptimizeStops() {
	var requestStr = $('#postTestRequest').val();
	var request = JSON.parse(requestStr);
	//clear
	$('#result').text('');
	$('#get_url').text('');
	$('#geturl').hide();
	map.entities.clear();

	postit(resturl +'POSTOptimize', {
		data: JSON.stringify(request),
		success: function (data) {
			$('#jsonresult').show();
			var resp = JSON.stringify(data, null, '\t');
			//process results
			if (showmap) {
				renderMap(data);
			}
			else {
				//show json results
				$('#result').text(resp);
			}
		},
		error: function (err) {
			$('#result').text(JSON.stringify(err, null, '\t'));
		}
	});
}

function post_RealRoadOptimizeStops() {
	var requestStr = $('#postTestRequest').val();
	requestStr = requestStr.replace("basic","realroadcar");
	var request = JSON.parse(requestStr);
	//clear
	$('#result').text('');
	$('#get_url').text('');
	$('#geturl').hide();

	map.entities.clear();
	postit(resturl +'POSTOptimize', {
		data: JSON.stringify(request),
		success: function (data) {
			var resp = JSON.stringify(data, null, '\t');
			if (showmap) {
				renderMap(data);
			}
			else {
				//show json results
				$('#result').text(resp);
			}
		},
		error: function (err) {
			$('#result').text(JSON.stringify(err, null, '\t'));
		}
	});
}

function get_BasicOptimizeStops() {
	var requestStr = $('#postTestRequest').val();
	//clear
	$('#result').text('');
	map.entities.clear();
	$('#geturl').show();

	var url = resturl + 'GETOptimize?query=' + requestStr;
	$('#get_url').text( url);
	$.getJSON(url, function (data) {
		if (showmap) {
			renderMap(data);
		}
		else {
			//show json results
			$('#result').text(JSON.stringify(data, null, '\t'));
		}
		
	});
}

function get_RealRoadOptimizeStops() {
	
	var requestStr = $('#postTestRequest').val();
	requestStr = requestStr.replace("basic", "realroadcar");
	//clear
	$('#result').text('');
	map.entities.clear();
	$('#geturl').show();
	var url = resturl + 'GETOptimize?query=' + requestStr;
	$('#get_url').text(url);
	
	$.getJSON(url, function (data) {
		if (showmap) {
			renderMap(data);
		}
		else {
			//show json results
			$('#result').text(JSON.stringify(data, null, '\t'));
		}

	});
}

// post json data and get a json response
function postit(url, options) {
	// extend options
	var poptions = jQuery.extend({}, {
		url: url,
		type: 'POST',
		contentType: 'application/json',
		dataType: 'json',
		error: function (jqXHR, exception) {
			var msg = '';
			if (jqXHR.status === 0) {
				msg = 'Not connect.\n Verify Network.';
			} else if (jqXHR.status === 404) {
				msg = 'Requested page not found. [404]';
			} else if (jqXHR.status === 500) {
				msg = 'Internal Server Error [500].';
			} else if (exception === 'parsererror') {
				msg = 'Requested JSON parse failed.';
			} else if (exception === 'timeout') {
				msg = 'Time out error.';
			} else if (exception === 'abort') {
				msg = 'Ajax request aborted.';
			} else {
				msg = 'Uncaught Error.\n' + jqXHR.responseText;
			}
			$('#postProduct').html(msg);
		},

	}, options);

	// send it along
	return $.ajax(poptions);
}

function renderMap(data) {

	var points = new Array();
	for (var i in data.Route.RoutePath) {
		points[i] = new Microsoft.Maps.Location(data.Route.RoutePath[i][0], data.Route.RoutePath[i][1]);
	}
	var path = new Microsoft.Maps.Polyline(points, { strokeColor: 'blue', strokeThickness: 2 });
	map.entities.push(path);

	for (var i in data.OptimizedStops) {
		var location = new Microsoft.Maps.Location(data.OptimizedStops[i].RouteLocation.Latitude, data.OptimizedStops[i].RouteLocation.Longitude);
		var c = 'orange';
		if (i == 0) c = 'green';
		else if (i == (data.OptimizedStops.length - 1)) c = 'red';
		var label = parseInt(i) + 1;
		map.entities.push(new Microsoft.Maps.Pushpin(location, { color: c, text: label.toString(), title: data.OptimizedStops[i].Name  }));
	}


	var bounds = new Microsoft.Maps.LocationRect.fromLocations(points);
	map.setView({ bounds: bounds });
}